"""All supported functions"""

from cpx_io.cpx_system.cpx_ap.ap_product_categories import ProductCategory

SUPPORTED_PRODUCT_FUNCTIONS_DICT = {
    "read_channels": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.IO_LINK,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
    ],
    "read_channel": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.IO_LINK,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
    ],
    "read_output_channels": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
    ],
    "read_output_channel": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
    ],
    "write_channels": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.IO_LINK,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
    ],
    "write_channel": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.IO_LINK,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
    ],
    "set_channel": [
        ProductCategory.DIGITAL,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
    ],
    "reset_channel": [
        ProductCategory.DIGITAL,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
    ],
    "toggle_channel": [
        ProductCategory.DIGITAL,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
    ],
    "write_module_parameter": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.IO_LINK,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
        ProductCategory.INTERFACE,
    ],
    "read_module_parameter": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.IO_LINK,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
        ProductCategory.INTERFACE,
    ],
    "read_module_parameter_enum_str": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.IO_LINK,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
        ProductCategory.INTERFACE,
    ],
    "read_diagnosis_code": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.IO_LINK,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
        ProductCategory.INTERFACE,
    ],
    "read_diagnosis_information": [
        ProductCategory.ANALOG,
        ProductCategory.DIGITAL,
        ProductCategory.IO_LINK,
        ProductCategory.VTOM,
        ProductCategory.VTSA,
        ProductCategory.VTUG,
        ProductCategory.VTUX,
        ProductCategory.MPA_L,
        ProductCategory.MPA_S,
        ProductCategory.INTERFACE,
    ],
    "read_system_parameters": [ProductCategory.INTERFACE],
    "read_pqi": [ProductCategory.IO_LINK],
    "read_fieldbus_parameters": [ProductCategory.IO_LINK],
    "read_isdu": [ProductCategory.IO_LINK],
    "write_isdu": [ProductCategory.IO_LINK],
}
INPUT_FUNCTIONS = {"read_channels", "read_channel"}
OUTPUT_FUNCTIONS = {
    "read_output_channels",
    "read_output_channel",
    "write_channels",
    "write_channel",
    "set_channel",
    "reset_channel",
    "toggle_channel",
}
PARAMETER_FUNCTIONS = {"write_module_parameter", "read_module_parameter"}
DIAGNOSIS_FUNCTIONS = {"read_diagnosis_code", "read_diagnosis_information"}
